using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Orpheu
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox imagem;
		private System.Windows.Forms.CheckBox visual_imag;
		private System.Windows.Forms.Button iniciar;
		private System.Windows.Forms.Button parar;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox cm_x;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox cm_y;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.NumericUpDown nivel_preto;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.NumericUpDown P;
		private System.Windows.Forms.NumericUpDown I;
		private System.Windows.Forms.NumericUpDown D;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.NumericUpDown tempo_amos;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Button actualizar;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.NumericUpDown ajuste_dto;
		private System.Windows.Forms.NumericUpDown ajuste_esq;
		private WebCam_Capture.WebCamCapture WebCamCapture;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private MccDaq.MccBoard DaqBoard;
		const MccDaq.Range Range = MccDaq.Range.Uni5Volts;
		const MccDaq.DigitalPortType PortNum = MccDaq.DigitalPortType.FirstPortA;
		const MccDaq.DigitalPortDirection Direction = MccDaq.DigitalPortDirection.DigitalOut;	
		//Variaveis para o PID para os motores.
		private float uk1_1=0, ek_1=0, ek1_1=0, ek2_1=0, uk1_2=0, ek_2=0, ek1_2=0, ek2_2=0, uk_1, uk_2;
		//Variaveis para o PID para a velocidade.
		private float uk_y=0, uk1_y=0, ek_y=0, ek1_y=0, ek2_y=0;
		//Variavel que permite ligar os motores do Orpheu.
		private int aux = 0;

		private System.Windows.Forms.Button iniciaM;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox piddto;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox pidesq;
		private System.Windows.Forms.NumericUpDown Dy;
		private System.Windows.Forms.NumericUpDown Iy;
		private System.Windows.Forms.NumericUpDown Py;
		private System.Windows.Forms.TextBox PIDy;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Button pararM;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			MccDaq.ErrorInfo ULStat = MccDaq.MccService.ErrHandling(MccDaq.ErrorReporting.PrintAll, MccDaq.ErrorHandling.StopAll);
			DaqBoard = new MccDaq.MccBoard(1);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.imagem = new System.Windows.Forms.PictureBox();
			this.visual_imag = new System.Windows.Forms.CheckBox();
			this.iniciar = new System.Windows.Forms.Button();
			this.parar = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.cm_x = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.cm_y = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.nivel_preto = new System.Windows.Forms.NumericUpDown();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.P = new System.Windows.Forms.NumericUpDown();
			this.I = new System.Windows.Forms.NumericUpDown();
			this.D = new System.Windows.Forms.NumericUpDown();
			this.label9 = new System.Windows.Forms.Label();
			this.tempo_amos = new System.Windows.Forms.NumericUpDown();
			this.label10 = new System.Windows.Forms.Label();
			this.actualizar = new System.Windows.Forms.Button();
			this.label12 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.ajuste_dto = new System.Windows.Forms.NumericUpDown();
			this.ajuste_esq = new System.Windows.Forms.NumericUpDown();
			this.WebCamCapture = new WebCam_Capture.WebCamCapture();
			this.iniciaM = new System.Windows.Forms.Button();
			this.pararM = new System.Windows.Forms.Button();
			this.label15 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.piddto = new System.Windows.Forms.TextBox();
			this.label17 = new System.Windows.Forms.Label();
			this.pidesq = new System.Windows.Forms.TextBox();
			this.Dy = new System.Windows.Forms.NumericUpDown();
			this.Iy = new System.Windows.Forms.NumericUpDown();
			this.Py = new System.Windows.Forms.NumericUpDown();
			this.PIDy = new System.Windows.Forms.TextBox();
			this.label18 = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.nivel_preto)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.P)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.I)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.D)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.tempo_amos)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ajuste_dto)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ajuste_esq)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.Dy)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.Iy)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.Py)).BeginInit();
			this.SuspendLayout();
			// 
			// imagem
			// 
			this.imagem.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.imagem.Location = new System.Drawing.Point(8, 8);
			this.imagem.Name = "imagem";
			this.imagem.Size = new System.Drawing.Size(272, 232);
			this.imagem.TabIndex = 0;
			this.imagem.TabStop = false;
			// 
			// visual_imag
			// 
			this.visual_imag.Checked = true;
			this.visual_imag.CheckState = System.Windows.Forms.CheckState.Checked;
			this.visual_imag.Location = new System.Drawing.Point(200, 252);
			this.visual_imag.Name = "visual_imag";
			this.visual_imag.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.visual_imag.Size = new System.Drawing.Size(72, 28);
			this.visual_imag.TabIndex = 2;
			this.visual_imag.Text = "Visualizar Imagem";
			this.visual_imag.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// iniciar
			// 
			this.iniciar.Location = new System.Drawing.Point(16, 256);
			this.iniciar.Name = "iniciar";
			this.iniciar.TabIndex = 3;
			this.iniciar.Text = "Iniciar";
			this.iniciar.Click += new System.EventHandler(this.iniciar_Click);
			// 
			// parar
			// 
			this.parar.Location = new System.Drawing.Point(112, 256);
			this.parar.Name = "parar";
			this.parar.TabIndex = 4;
			this.parar.Text = "Parar";
			this.parar.Click += new System.EventHandler(this.parar_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(36, 292);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "Centro de Massa:";
			// 
			// cm_x
			// 
			this.cm_x.Location = new System.Drawing.Point(132, 288);
			this.cm_x.Name = "cm_x";
			this.cm_x.Size = new System.Drawing.Size(44, 20);
			this.cm_x.TabIndex = 6;
			this.cm_x.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(176, 292);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 16);
			this.label2.TabIndex = 7;
			this.label2.Text = "x,";
			// 
			// cm_y
			// 
			this.cm_y.Location = new System.Drawing.Point(192, 288);
			this.cm_y.Name = "cm_y";
			this.cm_y.Size = new System.Drawing.Size(44, 20);
			this.cm_y.TabIndex = 8;
			this.cm_y.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(240, 292);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(16, 16);
			this.label3.TabIndex = 9;
			this.label3.Text = "y";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(68, 320);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(84, 16);
			this.label4.TabIndex = 10;
			this.label4.Text = "Nvel de Preto:";
			// 
			// nivel_preto
			// 
			this.nivel_preto.Location = new System.Drawing.Point(148, 316);
			this.nivel_preto.Maximum = new System.Decimal(new int[] {
																		255,
																		0,
																		0,
																		0});
			this.nivel_preto.Name = "nivel_preto";
			this.nivel_preto.Size = new System.Drawing.Size(68, 20);
			this.nivel_preto.TabIndex = 11;
			this.nivel_preto.Value = new System.Decimal(new int[] {
																	  35,
																	  0,
																	  0,
																	  0});
			// 
			// label5
			// 
			this.label5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(380, 8);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(136, 24);
			this.label5.TabIndex = 12;
			this.label5.Text = "Controlador PID";
			// 
			// label6
			// 
			this.label6.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label6.Location = new System.Drawing.Point(312, 60);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(64, 16);
			this.label6.TabIndex = 13;
			this.label6.Text = "Ganho, P =";
			// 
			// label7
			// 
			this.label7.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label7.Location = new System.Drawing.Point(300, 84);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(76, 16);
			this.label7.TabIndex = 14;
			this.label7.Text = "Integrador, I =";
			// 
			// label8
			// 
			this.label8.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label8.Location = new System.Drawing.Point(296, 108);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(80, 16);
			this.label8.TabIndex = 15;
			this.label8.Text = "Derivador, D =";
			// 
			// P
			// 
			this.P.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.P.DecimalPlaces = 2;
			this.P.Increment = new System.Decimal(new int[] {
																1,
																0,
																0,
																131072});
			this.P.Location = new System.Drawing.Point(396, 56);
			this.P.Maximum = new System.Decimal(new int[] {
															  1000,
															  0,
															  0,
															  0});
			this.P.Minimum = new System.Decimal(new int[] {
															  1000,
															  0,
															  0,
															  -2147483648});
			this.P.Name = "P";
			this.P.Size = new System.Drawing.Size(64, 20);
			this.P.TabIndex = 16;
			this.P.Value = new System.Decimal(new int[] {
															7,
															0,
															0,
															131072});
			// 
			// I
			// 
			this.I.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.I.DecimalPlaces = 2;
			this.I.Increment = new System.Decimal(new int[] {
																1,
																0,
																0,
																131072});
			this.I.Location = new System.Drawing.Point(396, 80);
			this.I.Maximum = new System.Decimal(new int[] {
															  410065408,
															  2,
															  0,
															  0});
			this.I.Minimum = new System.Decimal(new int[] {
															  900000000,
															  0,
															  0,
															  -2147483648});
			this.I.Name = "I";
			this.I.Size = new System.Drawing.Size(64, 20);
			this.I.TabIndex = 17;
			this.I.Value = new System.Decimal(new int[] {
															410065408,
															2,
															0,
															0});
			// 
			// D
			// 
			this.D.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.D.DecimalPlaces = 2;
			this.D.Increment = new System.Decimal(new int[] {
																1,
																0,
																0,
																131072});
			this.D.Location = new System.Drawing.Point(396, 104);
			this.D.Minimum = new System.Decimal(new int[] {
															  100,
															  0,
															  0,
															  -2147483648});
			this.D.Name = "D";
			this.D.Size = new System.Drawing.Size(64, 20);
			this.D.TabIndex = 18;
			this.D.Value = new System.Decimal(new int[] {
															8,
															0,
															0,
															131072});
			// 
			// label9
			// 
			this.label9.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label9.Location = new System.Drawing.Point(316, 136);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(152, 16);
			this.label9.TabIndex = 19;
			this.label9.Text = "Tempo de amostragem, T0 =";
			// 
			// tempo_amos
			// 
			this.tempo_amos.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.tempo_amos.Location = new System.Drawing.Point(464, 132);
			this.tempo_amos.Maximum = new System.Decimal(new int[] {
																	   32000,
																	   0,
																	   0,
																	   0});
			this.tempo_amos.Minimum = new System.Decimal(new int[] {
																	   1,
																	   0,
																	   0,
																	   0});
			this.tempo_amos.Name = "tempo_amos";
			this.tempo_amos.Size = new System.Drawing.Size(64, 20);
			this.tempo_amos.TabIndex = 20;
			this.tempo_amos.Value = new System.Decimal(new int[] {
																	 100,
																	 0,
																	 0,
																	 0});
			// 
			// label10
			// 
			this.label10.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label10.Location = new System.Drawing.Point(528, 136);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(20, 16);
			this.label10.TabIndex = 21;
			this.label10.Text = "ms";
			// 
			// actualizar
			// 
			this.actualizar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.actualizar.Location = new System.Drawing.Point(380, 160);
			this.actualizar.Name = "actualizar";
			this.actualizar.Size = new System.Drawing.Size(120, 23);
			this.actualizar.TabIndex = 22;
			this.actualizar.Text = "Actualizar";
			this.actualizar.Click += new System.EventHandler(this.actualizar_Click);
			// 
			// label12
			// 
			this.label12.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label12.Location = new System.Drawing.Point(404, 240);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(80, 24);
			this.label12.TabIndex = 25;
			this.label12.Text = "Afinaes";
			// 
			// label14
			// 
			this.label14.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label14.Location = new System.Drawing.Point(344, 296);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(144, 16);
			this.label14.TabIndex = 27;
			this.label14.Text = "Ajuste do motor Esquerdo =";
			// 
			// label13
			// 
			this.label13.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label13.Location = new System.Drawing.Point(360, 272);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(132, 16);
			this.label13.TabIndex = 28;
			this.label13.Text = "Ajuste do motor Direito =";
			// 
			// ajuste_dto
			// 
			this.ajuste_dto.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.ajuste_dto.Location = new System.Drawing.Point(484, 292);
			this.ajuste_dto.Maximum = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.ajuste_dto.Name = "ajuste_dto";
			this.ajuste_dto.Size = new System.Drawing.Size(64, 20);
			this.ajuste_dto.TabIndex = 29;
			this.ajuste_dto.Value = new System.Decimal(new int[] {
																	 830,
																	 0,
																	 0,
																	 0});
			// 
			// ajuste_esq
			// 
			this.ajuste_esq.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.ajuste_esq.Location = new System.Drawing.Point(484, 268);
			this.ajuste_esq.Maximum = new System.Decimal(new int[] {
																	   1000,
																	   0,
																	   0,
																	   0});
			this.ajuste_esq.Name = "ajuste_esq";
			this.ajuste_esq.Size = new System.Drawing.Size(64, 20);
			this.ajuste_esq.TabIndex = 30;
			this.ajuste_esq.Value = new System.Decimal(new int[] {
																	 840,
																	 0,
																	 0,
																	 0});
			// 
			// WebCamCapture
			// 
			this.WebCamCapture.CaptureHeight = 240;
			this.WebCamCapture.CaptureWidth = 320;
			// TODO: Code generation for 'this.WebCamCapture.FrameNumber' failed because of Exception 'Invalid Primitive Type: System.UInt64. Only CLS compliant primitive types can be used. Consider using CodeObjectCreateExpression.'.
			this.WebCamCapture.Location = new System.Drawing.Point(12, 18);
			this.WebCamCapture.Name = "WebCamCapture";
			this.WebCamCapture.Size = new System.Drawing.Size(342, 252);
			this.WebCamCapture.TabIndex = 0;
			this.WebCamCapture.TimeToCapture_milliseconds = 100;
			this.WebCamCapture.ImageCaptured += new WebCam_Capture.WebCamCapture.WebCamEventHandler(this.imagem_capturada);
			// 
			// iniciaM
			// 
			this.iniciaM.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.iniciaM.Location = new System.Drawing.Point(312, 320);
			this.iniciaM.Name = "iniciaM";
			this.iniciaM.Size = new System.Drawing.Size(116, 23);
			this.iniciaM.TabIndex = 31;
			this.iniciaM.Text = "Iniciar Motores";
			this.iniciaM.Click += new System.EventHandler(this.iniciaM_Click);
			// 
			// pararM
			// 
			this.pararM.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pararM.Location = new System.Drawing.Point(452, 320);
			this.pararM.Name = "pararM";
			this.pararM.Size = new System.Drawing.Size(116, 23);
			this.pararM.TabIndex = 32;
			this.pararM.Text = "Parar Motores";
			this.pararM.Click += new System.EventHandler(this.pararM_Click);
			// 
			// label15
			// 
			this.label15.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label15.Location = new System.Drawing.Point(296, 192);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(140, 16);
			this.label15.TabIndex = 33;
			this.label15.Text = "Valor do PID para o motor:";
			// 
			// label16
			// 
			this.label16.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label16.Location = new System.Drawing.Point(544, 192);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(24, 16);
			this.label16.TabIndex = 37;
			this.label16.Text = "dto.";
			// 
			// piddto
			// 
			this.piddto.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.piddto.Location = new System.Drawing.Point(500, 188);
			this.piddto.Name = "piddto";
			this.piddto.Size = new System.Drawing.Size(44, 20);
			this.piddto.TabIndex = 36;
			this.piddto.Text = "";
			// 
			// label17
			// 
			this.label17.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label17.Location = new System.Drawing.Point(472, 192);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(32, 16);
			this.label17.TabIndex = 35;
			this.label17.Text = "esq.,";
			// 
			// pidesq
			// 
			this.pidesq.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pidesq.Location = new System.Drawing.Point(428, 188);
			this.pidesq.Name = "pidesq";
			this.pidesq.Size = new System.Drawing.Size(44, 20);
			this.pidesq.TabIndex = 34;
			this.pidesq.Text = "";
			// 
			// Dy
			// 
			this.Dy.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.Dy.DecimalPlaces = 2;
			this.Dy.Increment = new System.Decimal(new int[] {
																 1,
																 0,
																 0,
																 131072});
			this.Dy.Location = new System.Drawing.Point(492, 104);
			this.Dy.Minimum = new System.Decimal(new int[] {
															   100,
															   0,
															   0,
															   -2147483648});
			this.Dy.Name = "Dy";
			this.Dy.Size = new System.Drawing.Size(64, 20);
			this.Dy.TabIndex = 40;
			// 
			// Iy
			// 
			this.Iy.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.Iy.DecimalPlaces = 2;
			this.Iy.Increment = new System.Decimal(new int[] {
																 1,
																 0,
																 0,
																 131072});
			this.Iy.Location = new System.Drawing.Point(492, 80);
			this.Iy.Maximum = new System.Decimal(new int[] {
															   410065408,
															   2,
															   0,
															   0});
			this.Iy.Minimum = new System.Decimal(new int[] {
															   900000000,
															   0,
															   0,
															   -2147483648});
			this.Iy.Name = "Iy";
			this.Iy.Size = new System.Drawing.Size(64, 20);
			this.Iy.TabIndex = 39;
			this.Iy.Value = new System.Decimal(new int[] {
															 410065408,
															 2,
															 0,
															 0});
			// 
			// Py
			// 
			this.Py.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.Py.DecimalPlaces = 2;
			this.Py.Increment = new System.Decimal(new int[] {
																 1,
																 0,
																 0,
																 131072});
			this.Py.Location = new System.Drawing.Point(492, 56);
			this.Py.Maximum = new System.Decimal(new int[] {
															   1000,
															   0,
															   0,
															   0});
			this.Py.Minimum = new System.Decimal(new int[] {
															   1000,
															   0,
															   0,
															   -2147483648});
			this.Py.Name = "Py";
			this.Py.Size = new System.Drawing.Size(64, 20);
			this.Py.TabIndex = 38;
			this.Py.Value = new System.Decimal(new int[] {
															 27,
															 0,
															 0,
															 131072});
			// 
			// PIDy
			// 
			this.PIDy.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.PIDy.Location = new System.Drawing.Point(488, 212);
			this.PIDy.Name = "PIDy";
			this.PIDy.Size = new System.Drawing.Size(44, 20);
			this.PIDy.TabIndex = 41;
			this.PIDy.Text = "";
			// 
			// label18
			// 
			this.label18.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label18.Location = new System.Drawing.Point(328, 216);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(176, 16);
			this.label18.TabIndex = 42;
			this.label18.Text = "Valor do PID para a velocidader:";
			// 
			// label19
			// 
			this.label19.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label19.Location = new System.Drawing.Point(472, 40);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(8, 88);
			this.label19.TabIndex = 43;
			this.label19.Text = "||||||||";
			// 
			// label20
			// 
			this.label20.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label20.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label20.Location = new System.Drawing.Point(492, 36);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(64, 16);
			this.label20.TabIndex = 44;
			this.label20.Text = "Velocidade";
			// 
			// label21
			// 
			this.label21.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label21.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label21.Location = new System.Drawing.Point(404, 36);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(48, 16);
			this.label21.TabIndex = 45;
			this.label21.Text = "Motores";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 350);
			this.Controls.Add(this.label21);
			this.Controls.Add(this.label20);
			this.Controls.Add(this.label19);
			this.Controls.Add(this.PIDy);
			this.Controls.Add(this.label18);
			this.Controls.Add(this.Dy);
			this.Controls.Add(this.Iy);
			this.Controls.Add(this.Py);
			this.Controls.Add(this.label16);
			this.Controls.Add(this.piddto);
			this.Controls.Add(this.label17);
			this.Controls.Add(this.pidesq);
			this.Controls.Add(this.label15);
			this.Controls.Add(this.pararM);
			this.Controls.Add(this.iniciaM);
			this.Controls.Add(this.ajuste_esq);
			this.Controls.Add(this.ajuste_dto);
			this.Controls.Add(this.label13);
			this.Controls.Add(this.label14);
			this.Controls.Add(this.label12);
			this.Controls.Add(this.actualizar);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.tempo_amos);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.D);
			this.Controls.Add(this.I);
			this.Controls.Add(this.P);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.nivel_preto);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cm_y);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.cm_x);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.parar);
			this.Controls.Add(this.iniciar);
			this.Controls.Add(this.visual_imag);
			this.Controls.Add(this.imagem);
			this.Name = "Form1";
			this.Text = "Orpheu";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.nivel_preto)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.P)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.I)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.D)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.tempo_amos)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ajuste_dto)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ajuste_esq)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.Dy)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.Iy)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.Py)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//Indicao do tamanho da janela
			this.WebCamCapture.Width = this.imagem.Width;
			this.WebCamCapture.Height = this.imagem.Height;
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			//Para a captura de imagem e os motores.
			this.WebCamCapture.Stop();
			this.Dispose();
			stop_motors();
		}

		private void parar_Click(object sender, System.EventArgs e)
		{
			//Para a captura de imagem e os motores.
			this.WebCamCapture.Stop();
		}

		private void iniciar_Click(object sender, System.EventArgs e)
		{
			//V qual  o tempo de amostragem de imagens e inicia a captura.
			this.WebCamCapture.TimeToCapture_milliseconds = (int) this.tempo_amos.Value;
			this.WebCamCapture.Start(0);
		}

		private void stop_motors()
		{
			DaqBoard.AOut(0, Range, 0);
			DaqBoard.AOut(1, Range, 0);
		}

		private void move_left_right_motors (decimal left, decimal right)
		{
			DaqBoard.AOut(0, Range, (ushort)left);
			DaqBoard.AOut(1, Range, (ushort)right);
		}

		private void actualizar_Click(object sender, System.EventArgs e)
		{
			//V qual  o tempo de amostragem de imagens e actualiza.
			this.WebCamCapture.TimeToCapture_milliseconds = (int) this.tempo_amos.Value;
			this.WebCamCapture.Start(this.WebCamCapture.FrameNumber);
			//Pe as variveis dos PID's a zero.
			this.ek_1 = this.ek1_1 = this.ek2_1 = this.uk_1 = this.uk1_1 = 0;
			this.ek_2 = this.ek1_2 = this.ek2_2 = this.uk_2 = this.uk1_2 = 0;
			this.ek_y = this.ek1_y = this.ek2_y = this.uk_y = this.uk1_y = 0;
		}

		private void imagem_capturada(object source, WebCam_Capture.WebcamEventArgs e)
		{
			# region Calculo do centro de massa
			///
			/// Feito por Carlos Cardeira e Luis Lau 2004
			///
			
			Bitmap Img;
			Color pixel;
			int x_mass_centre, y_mass_centre;
			
			Img = (System.Drawing.Bitmap) e.WebCamImage;
		
			int x, y, nx=0, ny=0, dxy=0, black_or_white, BLACK=0, WHITE=1 ;
			for (y=0; y<Img.Height; y+=5)
				for (x=0; x<Img.Width; x+=5)
				{
					pixel = Img.GetPixel (x,y) ;
					black_or_white = (((pixel.R + pixel.G + pixel.B)/3) > (int)this.nivel_preto.Value) ? BLACK:WHITE ;
					if (black_or_white == WHITE) 
					{
						nx += x ;
						ny += y ;
						dxy ++ ;
						Img.SetPixel(x, y, Color.White) ;
					}
					else Img.SetPixel(x, y, Color.Black) ;
				}
			if (dxy > 0) 
			{
				x_mass_centre = nx/dxy ;
				y_mass_centre = ny/dxy ;
			}
			else 
			{
				x_mass_centre = this.imagem.Width/2 ;
				y_mass_centre = this.imagem.Height/2 ;
			}

			for (x = (x_mass_centre - 10 < 0) ? 0 : x_mass_centre - 10 ; 
				x < ((x_mass_centre + 10 > (int)this.imagem.Width) ? 
				(int)this.imagem.Width : x_mass_centre + 10);
				x++)  
			{
				Img.SetPixel (x, y_mass_centre, Color.Red);
			}

			for (y = (y_mass_centre - 10 < 0) ? 0 : y_mass_centre - 10 ;
				y < ((y_mass_centre + 10 > (int)this.imagem.Height) ?
				(int)this.imagem.Height : y_mass_centre + 10) ; y++)  
			{
				Img.SetPixel (x_mass_centre, y, Color.Red);
			}

			this.cm_x.Text = x_mass_centre.ToString();
			this.cm_y.Text = y_mass_centre.ToString();

			#endregion

			// Calculo do valor dos PID.
			float q0, q1, q2, k, tau_i, tau_d, T0, q0_y, q1_y, q2_y, ky, tau_iy, tau_dy;

			k = (float) this.P.Value;
			tau_i = (float) this.I.Value;
			tau_d = (float) this.D.Value;
			T0 = (float) this.tempo_amos.Value / 1000;

			q0 = k*(1+(tau_d/T0)+(T0/(2*tau_i)));
			q1 = -k*(1+2*(tau_d/T0)-(T0/(2*tau_i)));
			q2 = (k*tau_d)/T0;

			//PID digital para a roda direira. Variaveis com _1
			this.ek2_1 = this.ek1_1;
			this.ek1_1 = this.ek_1;
			this.ek_1 = x_mass_centre-5;
            this.uk_1 = this.uk1_1+q0*this.ek_1+q1*this.ek1_1+q2*this.ek2_1;
			this.uk1_1 = this.uk_1;
			this.uk_1 = this.uk_1 + (int) this.ajuste_dto.Value;

			//PID digital para a roda esquerda. Variaveis com _2
			this.ek2_2 = this.ek1_2;
			this.ek1_2 = this.ek_2;
			this.ek_2 = (int) this.imagem.Width - x_mass_centre+5;
			this.uk_2 = this.uk1_2+q0*this.ek_2+q1*this.ek1_2+q2*this.ek2_2;
			this.uk1_2 = this.uk_2;
			this.uk_2 = this.uk_2 + (int) this.ajuste_esq.Value;

			//Controlo de velocidade automtico. Tem como objectivo manter
			//o Orpheu a uma distncia de segurana do alvo.
			ky = (float) this.Py.Value;
			tau_iy = (float) this.Iy.Value;
			tau_dy = (float) this.Dy.Value;

			q0_y = ky*(1+(tau_dy/T0)+(T0/(2*tau_iy)));
			q1_y = -ky*(1+2*(tau_dy/T0)-(T0/(2*tau_iy)));
			q2_y = (ky*tau_dy)/T0;

			this.ek2_y = this.ek1_y;
			this.ek1_y = this.ek_y;
			this.ek_y = y_mass_centre;
			this.uk_y = this.uk1_y+q0_y*this.ek_y+q1_y*this.ek1_y+q2_y*this.ek2_y;
			this.uk1_y = this.uk_y;
			this.uk_y = this.uk_y;

			// O valor deste PID  subtraido ao valor do PID de cada motor, deste modo, ao
			//controlar a velocidade, podemos controlar a distncia do Orpheu ao alvo.
			this.uk_1 = this.uk_1 - this.uk_y;
			this.uk_2 = this.uk_2 - this.uk_y;

			this.PIDy.Text = uk_y.ToString();
			
			//Abaixo de 100 pixels, a contar da parte inferior da imagem, o Orfeu pra.
			if(this.imagem.Width - y_mass_centre <= 100)
			{
				uk_1 = 0;
				uk_2 = 0;
			}

			//Devido ao tipo de rob a velocidade s pode ter valores positivos.
			if (this.uk_1 < 0) this.uk_1 = 0;
			if (this.uk_2 < 0) this.uk_2 = 0;

			this.pidesq.Text = uk_1.ToString();
			this.piddto.Text = uk_2.ToString();

			//Primeiro o valor para a roda esquerda e depois pra a roda direita.
			if (aux == 1 ) move_left_right_motors ((int)uk_1,(int)uk_2);	
			
			// Apresenta a imagem capturada.
			if( this.visual_imag.Checked)this.imagem.Image = e.WebCamImage;
		}

		private void iniciaM_Click(object sender, System.EventArgs e)
		{
			aux = 1;
		}

		private void pararM_Click(object sender, System.EventArgs e)
		{
			stop_motors();
			aux = 0;
		}
	}
}
